import utils, math

class Trainer():
    def __init__(self):
        self.utils = utils.Utils()

    def feedforward(self):
        # select only inputs that are the query words
        for i in range(len(self.utils.iu)): self.utils.si[i] = 1.0
        # hidden activations
        for j in range(len(self.utils.hu)):
            sum = 0.0
            for i in range(len(self.utils.iu)): sum = sum + self.utils.si[i] * self.utils.i[i][j]
            self.utils.sh[j] = math.tanh(sum)
        # output activations
        for k in range(len(self.utils.ou)):
            sum = 0.0
            for j in range(len(self.utils.hu)): sum = sum + self.utils.sh[j] * self.utils.o[j][k]
            self.utils.so[k] = math.tanh(sum)
        return self.utils.so[:]

    def backpropagate(self,targets,n=0.5):
        # calculate errors for output
        odeltas = [0.0] * len(self.utils.ou)
        for k in range(len(self.utils.ou)):
            error = targets[k] - self.utils.so[k]
            odeltas[k] = self.utils.dtanh(self.utils.so[k]) * error
        # calculate errors for hidden layer
        hdeltas = [0.0] * len(self.utils.hu)
        for j in range(len(self.utils.hu)):
            error = 0.0
            for k in range(len(self.utils.ou)):
                error = error + odeltas[k]*self.utils.o[j][k]
            hdeltas[j] = self.utils.dtanh(self.utils.sh[j]) * error
        for j in range(len(self.utils.hu)):
            for k in range(len(self.utils.ou)):
                change = odeltas[k]*self.utils.sh[j]
                self.utils.o[j][k] = self.utils.o[j][k] + n*change
        # update input weights
        for i in range(len(self.utils.iu)):
            for j in range(len(self.utils.hu)):
                change = hdeltas[j]*self.utils.si[i]
                self.utils.i[i][j] = self.utils.i[i][j] + n*change

    def train(self,inputs,outputs,match):
        self.utils.generatesynapses(inputs,outputs)
        self.utils.setupnetwork(inputs,outputs)
        self.feedforward()
        targets=[0.0]*len(outputs)
        targets[outputs.index(match)] = 1.0
        error = self.backpropagate(targets)
        self.utils.updatedataset()

